﻿using System;
using System.Data;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;

/// <summary>
/// Summary description for ModelFacade
/// </summary>
public class ModelFacade
{
	public ModelFacade()
	{
		//
		// TODO: Add constructor logic here
		//
	}
    
    public Claim createClaim(ClaimFormDTO dto)
    {
        Claim claim = new Claim();
 // we only create a policy here because we do not yet
 // use a database. More realistically, the Policy
 // would already exist and need to be retrieved
        Policy policy = new Policy();
 // we must set up the relationship between Claim and Policy
 // before attempting to generate the reference, because the 
 // ReferenceGenerator uses properties from both classes
        claim.Policy = policy;
        claim.Policy.Number = Int32.Parse(dto.PolicyNumber);
        claim.Policy.Type = dto.PolicyType;
        claim.Amount = dto.ClaimAmount;
        claim.Description = dto.ClaimDescription;
        claim.DateOfClaim = DateTime.Now;
        claim.IsApproved = false;
        ReferenceGenerator generator = new ReferenceGenerator();
        String reference = generator.getReference(claim);
        claim.Reference = reference;
        return claim;
    }

    public double getQuote(BuildingsDTO dto)
    {
        QuoteProcessor quoter = new QuoteProcessor();
        return quoter.getBuildingsQuote(dto);
    }

    public double getQuote(ContentsDTO dto)
    {
        QuoteProcessor quoter = new QuoteProcessor();
        return quoter.getContentsQuote(dto);
    }
}
